module Main where

import GCLParser.Parser
import GCLParser.GCLAlgebra

import GCLLexer.Lexer

import System.Environment

import WLP.LogicalExpression
import WLP.ProgramPath
import WLP.WLPCalculator

main :: IO ()
main = do
    [fp] <- getArgs
    file <- readFile fp
    let tokens = lexer file
    putStrLn "Tokens: "
    putStrLn . show $ tokens

    let parsed = parseGCL tokens
    case parsed of
      Left xs -> putStrLn "Could not parse program. Error:" >> print xs
      Right program -> do
        -- We gotta turn the AST into a logical formula based on the wlp
        let paths = getProgramPaths maxPathLength program

        putStrLn "Program paths: "
        sequence_ ((\p -> putStrLn $ show p) <$> paths)

maxPathLength :: Int
maxPathLength = 20

